This folder contains the codebase used in our experiments. 

Our code is built on AllenNLP and requires [AllenNLP](https://github.com/allenai/allennlp) and [AllenNLP-Models](https://github.com/allenai/allennlp-models/) to run. 

Our Anaconda virtual environment for executing our code is specified below:
```
name: allennlp
channels:
  - conda-forge
  - defaults
dependencies:
  - appnope=0.1.0=py37_0
  - attrs=19.3.0=py_0
  - backcall=0.2.0=py_0
  - blas=1.0=mkl
  - bleach=3.1.5=py_0
  - brotlipy=0.7.0=py37haf1e3a3_1000
  - ca-certificates=2020.10.14=0
  - certifi=2020.11.8=py37hecd8cb5_0
  - cffi=1.14.0=py37hc512035_1
  - chardet=3.0.4=py37_1003
  - cryptography=2.9.2=py37ha12b0ac_0
  - decorator=4.4.2=py_0
  - defusedxml=0.6.0=py_0
  - entrypoints=0.3=py37_0
  - freetype=2.10.4=ha233b18_0
  - gitdb=4.0.5=py_0
  - gitpython=3.1.8=py_1
  - idna=2.9=py_1
  - importlib-metadata=1.6.1=py37_0
  - importlib_metadata=1.6.1=0
  - intel-openmp=2019.4=233
  - ipykernel=5.3.0=py37h5ca1d4c_0
  - ipython=7.15.0=py37_0
  - ipython_genutils=0.2.0=py37_0
  - ipywidgets=7.5.1=py_0
  - jedi=0.17.1=py37_0
  - jinja2=2.11.2=py_0
  - jpeg=9b=he5867d9_2
  - json5=0.9.5=py_0
  - jsonschema=3.2.0=py37_0
  - jupyter_client=6.1.3=py_0
  - jupyter_core=4.6.3=py37_0
  - jupyterlab=2.1.4=py_1
  - jupyterlab_server=1.1.5=py_0
  - lcms2=2.11=h92f6f08_0
  - libcxx=10.0.0=1
  - libedit=3.1.20181209=hb402a30_0
  - libffi=3.3=h0a44026_1
  - libgfortran=3.0.1=h93005f0_2
  - libpng=1.6.37=ha441bb4_0
  - libsodium=1.0.16=h3efe00b_0
  - libtiff=4.1.0=hcb84e12_1
  - lz4-c=1.9.2=h79c402e_3
  - markupsafe=1.1.1=py37h1de35cc_0
  - matplotlib-base=3.3.2=py37h181983e_0
  - mistune=0.8.4=py37h1de35cc_0
  - mkl=2019.4=233
  - mkl-service=2.3.0=py37hfbe908c_0
  - mkl_fft=1.2.0=py37hc64f4ea_0
  - mkl_random=1.1.1=py37h959d312_0
  - nbconvert=5.6.1=py37_0
  - nbformat=5.0.7=py_0
  - ncurses=6.2=h0a44026_1
  - notebook=6.0.3=py37_0
  - numpy-base=1.19.2=py37hcfb5961_0
  - olefile=0.46=py37_0
  - openssl=1.1.1h=haf1e3a3_0
  - packaging=20.4=py_0
  - pandas=1.1.3=py37hb1e8313_0
  - pandoc=2.2.3.2=0
  - pandocfilters=1.4.2=py37_1
  - parso=0.7.0=py_0
  - pexpect=4.8.0=py37_0
  - pickleshare=0.7.5=py37_0
  - pillow=8.0.1=py37h5270095_0
  - pip=20.0.2=py37_3
  - prometheus_client=0.8.0=py_0
  - prompt-toolkit=3.0.5=py_0
  - ptyprocess=0.6.0=py37_0
  - pycparser=2.20=py_0
  - pygments=2.6.1=py_0
  - pyopenssl=19.1.0=py37_0
  - pyparsing=2.4.7=py_0
  - pyrsistent=0.16.0=py37h1de35cc_0
  - pysocks=1.7.1=py37_0
  - python=3.7.7=hf48f09d_4
  - python-dateutil=2.8.1=py_0
  - python_abi=3.7=1_cp37m
  - pytz=2020.4=pyhd3eb1b0_0
  - pyzmq=18.1.1=py37h0a44026_0
  - readline=8.0=h1de35cc_0
  - seaborn=0.11.0=py_0
  - send2trash=1.5.0=py37_0
  - setuptools=47.1.1=py37_0
  - six=1.15.0=py_0
  - smmap=3.0.4=py_0
  - sqlite=3.31.1=h5c1f38d_1
  - terminado=0.8.3=py37_0
  - testpath=0.4.4=py_0
  - tk=8.6.8=ha441bb4_0
  - tornado=6.0.4=py37h1de35cc_1
  - traitlets=4.3.3=py37_0
  - urllib3=1.25.9=py_0
  - wcwidth=0.2.4=py_0
  - wheel=0.34.2=py37_0
  - widgetsnbextension=3.5.1=py37hc8dfbb8_1
  - xz=5.2.5=h1de35cc_0
  - zeromq=4.3.1=h0a44026_3
  - zipp=3.1.0=py_0
  - zlib=1.2.11=h1de35cc_3
  - zstd=1.4.5=h41d2c2f_0
  - pip:
    - absl-py==0.10.0
    - apex==0.1
    - appdirs==1.4.4
    - black==20.8b1
    - blis==0.4.1
    - boto3==1.14.27
    - botocore==1.17.27
    - cachetools==4.1.1
    - catalogue==1.0.0
    - click==7.1.2
    - codecov==2.1.4
    - conllu==4.4
    - coverage==5.1
    - cycler==0.10.0
    - cymem==2.0.3
    - cython==0.29.21
    - deepdiff==5.0.2
    - docopt==0.6.2
    - docutils==0.15.2
    - en-core-web-sm==2.2.5
    - et-xmlfile==1.0.1
    - filelock==3.0.12
    - flake8==3.8.2
    - flaky==3.6.1
    - ftfy==5.8
    - future==0.18.2
    - google-auth==1.20.1
    - google-auth-oauthlib==0.4.1
    - grpcio==1.31.0
    - h5py==2.10.0
    - jdcal==1.4.1
    - jmespath==0.10.0
    - joblib==0.15.1
    - jsonlines==1.2.0
    - jsonnet==0.16.0
    - jsonpickle==1.4.1
    - keyring==21.2.1
    - kiwisolver==1.2.0
    - livereload==2.6.2
    - lmdb==1.1.1
    - lunr==0.5.8
    - markdown==3.2.2
    - markdown-include==0.6.0
    - matplotlib==3.2.1
    - mccabe==0.6.1
    - mkdocs==1.1.2
    - mkdocs-material==6.0.2
    - mkdocs-material-extensions==1.0
    - more-itertools==8.3.0
    - murmurhash==1.0.2
    - mypy==0.790
    - mypy-extensions==0.4.3
    - nltk==3.5
    - nr-collections==0.0.1
    - nr-databind-core==0.0.15
    - nr-databind-json==0.0.9
    - nr-interface==0.0.2
    - nr-metaclass==0.0.5
    - nr-parsing-date==0.1.0
    - nr-pylang-utils==0.0.2
    - nr-stream==0.0.3
    - numpy==1.18.5
    - oauthlib==3.1.0
    - omegaconf==2.0.3
    - openpyxl==2.4.11
    - ordered-set==4.0.2
    - overrides==3.1.0
    - pathspec==0.8.0
    - pathtools==0.1.2
    - pkginfo==1.5.0.1
    - plac==1.1.3
    - pluggy==0.13.1
    - portalocker==2.0.0
    - preshed==3.0.2
    - protobuf==3.12.2
    - py==1.8.1
    - py-cpuinfo==5.0.0
    - py-rouge==1.1
    - pyasn1==0.4.8
    - pyasn1-modules==0.2.8
    - pycodestyle==2.6.0
    - pydoc-markdown==3.0.2
    - pyflakes==2.2.0
    - pymdown-extensions==7.1
    - pytest==5.4.3
    - pytest-benchmark==3.2.3
    - pytest-cov==2.9.0
    - pyyaml==5.3.1
    - readme-renderer==26.0
    - records==0.5.3
    - regex==2020.6.8
    - requests==2.23.0
    - requests-oauthlib==1.3.0
    - requests-toolbelt==0.9.1
    - responses==0.10.14
    - rouge-score==0.0.4
    - rsa==4.6
    - ruamel-yaml==0.16.10
    - ruamel-yaml-clib==0.2.0
    - s3transfer==0.3.3
    - sacrebleu==1.4.13
    - sacremoses==0.0.43
    - scikit-learn==0.23.1
    - scipy==1.4.1
    - sentencepiece==0.1.91
    - spacy==2.2.4
    - sqlalchemy==1.3.20
    - srsly==1.0.2
    - stanza==1.1.1
    - tablib==2.0.0
    - tensorboard==2.3.0
    - tensorboard-plugin-wit==1.7.0
    - tensorboardx==2.0
    - thinc==7.4.0
    - threadpoolctl==2.1.0
    - tokenizers==0.10.1
    - toml==0.10.1
    - torch==1.8.0
    - torchvision==0.9.0
    - tqdm==4.46.1
    - twine==3.1.1
    - typed-ast==1.4.1
    - typing==3.7.4.1
    - typing-extensions==3.7.4.2
    - ujson==4.0.1
    - wasabi==0.6.0
    - watchdog==0.10.2
    - webencodings==0.5.1
    - werkzeug==1.0.1
    - word2number==1.1
```